; Jakub Madej B3

(defun string-subst2 (a b c d e an bn cn dn en txt)
	(let* (
		(apos (search a txt))
		(bpos (search b txt))
		(cpos (search c txt))
		(dpos (search d txt))
		(epos (search e txt))
		(minimalny 0)
	)
	
	(cond
		((not (numberp apos))
			(setf apos (length txt))
		)
	)
	(cond
		((not (numberp bpos))
			(setf bpos (length txt))
		)
	)
	(cond
		((not (numberp cpos))
			(setf cpos (length txt))
		)
	)
	(cond
		((not (numberp dpos))
			(setf dpos (length txt))
		)
	)
	(cond
		((not (numberp epos))
			(setf epos (length txt))
		)
	)
	
	(setf minimalny (min apos bpos cpos dpos epos))
	
	(cond
		((not (equal minimalny (length txt)))
			(cond
				((equal minimalny apos)
					(setf txt (concatenate 'string (subseq txt 0 apos) an (string-subst2 a b c d e an bn cn dn en (subseq txt (+ (length a) apos)))))
				)
			)
			(cond
				((equal minimalny bpos)
					(setf txt (concatenate 'string (subseq txt 0 bpos) bn (string-subst2 a b c d e an bn cn dn en (subseq txt (+ (length b) bpos)))))
				)
			)
			(cond
				((equal minimalny cpos)
					(setf txt (concatenate 'string (subseq txt 0 cpos) cn (string-subst2 a b c d e an bn cn dn en (subseq txt (+ (length c) cpos)))))
				)
			)
			(cond
				((equal minimalny dpos)
					(setf txt (concatenate 'string (subseq txt 0 dpos) dn (string-subst2 a b c d e an bn cn dn en (subseq txt (+ (length d) dpos)))))
				)
			)
			(cond
				((equal minimalny epos)
					(setf txt (concatenate 'string (subseq txt 0 epos) en (string-subst2 a b c d e an bn cn dn en (subseq txt (+ (length e) epos)))))
				)
			)
		)
	)
	txt
))

(defun usun-biale-znaki (str)
	(let (
		(znak nil)
	)
	(loop
		(setf znak (peek-char nil str))
		(cond
			((not (or (char-equal znak #\NewLine) (char-equal znak #\Tab) (char-equal znak #\Space)))
				(return)
			)
		)
		(read-char str)
	)
))

(defun usun-komentarz (str)
	(let (
		(znak nil)
		(znak2 nil)
		(napis nil)
	)
	(setf znak (peek-char nil str))
	(cond
		((not (char-equal znak #\<))
			(return-from usun-komentarz nil)
		)
	)
	
	;czy komentarz
	(setf znak (read-char str))
	(setf znak2 (peek-char nil str))
	(cond
		((not (or (char-equal znak2 #\!) (char-equal znak2 #\?)))
			(return-from usun-komentarz znak)
		)
	)
	
	;usuwanie

	(setf znak (read-char str))
	
	(dotimes (i 7)
		(setf znak (read-char str))
		(cond
			((char-equal znak #\>)
				(return)
			)
		)
		(setf napis (concatenate 'string napis (string znak)))
	)
	
	(cond
		((and (equal napis "[CDATA[") (char-equal znak2 #\!))
			(setf napis nil)
			(loop
				(setf znak (read-char str))
				(setf napis (concatenate 'string napis (string znak)))
				(cond
					((search "]]>" napis)
						(setf napis (subseq napis 0 (- (length napis) 3)))
						(usun-biale-znaki str)
						(return-from usun-komentarz napis)
					)
				)
			)			
		)
		(t
			(loop
				(setf znak (read-char str))
				(cond
					((char-equal znak #\>)
						(return)
					)
				)
			)
		)
	)
	
	(usun-biale-znaki str)
	(usun-komentarz str)
))

(defun wczytaj-wezel (str &optional (przestrzen nil))
	(let (
		(wezel (gensym))
		(znak nil)
		(nazwa nil)
		(atrybuty nil)
		(atrnazwa nil)
		(atrwartosc nil)
		(cudzyslow nil)
		(tresc nil)
		(przestrzenglob przestrzen)
	)
	
	;komentarze
	(usun-biale-znaki str)
	(usun-komentarz str)

	;nazwa
	(loop
		(setf znak (read-char str))
		(cond
			((or (char-equal znak #\>) (char-equal znak #\ ))
				(return)
			)
			((char-equal znak #\:)
				(setf przestrzen (gensym))
				(setf (get przestrzen 'nazwa) nazwa)
				(setf nazwa nil)
				(setf przestrzenglob nil)
			)
			(t
				(setf nazwa (concatenate 'string nazwa (string znak)))
			)
		)
	)
	
	(setf (get wezel 'nazwa) nazwa)
	(usun-biale-znaki str)

	;atrybuty
	(cond
		((char-equal znak #\ )
			(loop
				(setf atrnazwa nil)
				(setf atrwartosc nil)
				(cond
					((char-equal (peek-char nil str) #\>)
						(return)
					)
				)
				(loop
					(setf znak (read-char str))
					(cond
						((char-equal znak #\=)
							(return)
						)
					)
					(setf atrnazwa (concatenate 'string atrnazwa (string znak)))
				)
				(setf cudzyslow (read-char str))
				(loop
					(setf znak (read-char str))
					(cond
						((char-equal znak cudzyslow)
							(return)
						)
					)
					(setf atrwartosc (concatenate 'string atrwartosc (string znak)))
				)
				(setf (get wezel 'atrybuty) (append (get wezel 'atrybuty) `((,atrnazwa ,atrwartosc))))
				(usun-biale-znaki str)
			)
		)
	)

	;atrybuty -> przestrzen
	(dolist (i (get wezel 'atrybuty))
		(cond
			((equal (car i) "xmlns")
				(setf przestrzen (gensym))
				(setf (get przestrzen 'URI) (cadr i))
				(setf (get wezel 'atrybuty) (remove i (get wezel 'atrybuty) :test #'equal))
				(setf przestrzenglob t)
			)
		)
	)
	
	(cond
		((and przestrzen (not przestrzenglob))
			(let (
				(nazwaa (concatenate 'string "xmlns:" (get przestrzen 'nazwa)))
			)
			(dolist (i (get wezel 'atrybuty))
				(cond
					((equal (car i) nazwaa)
						(setf przestrzen (gensym))
						(setf (get przestrzen 'URI) (cadr i))
						(setf (get wezel 'atrybuty) (remove i (get wezel 'atrybuty) :test #'equal))
					)
				)
			)
		))
	)

	(setf (get wezel 'przestrzen) przestrzen)

	;reszta: tresc + wezly potomne
	(usun-biale-znaki str)
	(loop
		(setf znak (usun-komentarz str))
		(cond
			((not znak)
				(setf znak (read-char str))
			)
		)
		(cond
			((and (characterp znak) (char-equal znak #\<))
				(cond
					((char-equal (peek-char nil str) #\/)
						(return)
					)
					(t
						(cond
							(przestrzenglob
								(setf (get wezel 'wezly) (append (get wezel 'wezly) `(,(wczytaj-wezel str przestrzen))))
							)
							(t
								(setf (get wezel 'wezly) (append (get wezel 'wezly) `(,(wczytaj-wezel str))))
							)
						)
					)
				)
			)
			((stringp znak)
				(setf tresc (concatenate 'string tresc (string-subst2 "&" "a" "b" "c" "d" "&amp;" "a" "b" "c" "d" znak)))
			)
			(t
				(setf tresc (concatenate 'string tresc (string znak)))
			)
		)
	)
	
	;znaki specjalne
	(setf tresc (string-subst2 "&lt;" "&gt;" "&amp;" "&apos;" "&quot;" "<" ">" "&" "'" "\"" tresc))
	
	(setf (get wezel 'tresc) tresc)
	
	;koniec
	(loop
		(setf znak (read-char str))
		(cond
			((char-equal znak #\>)
				(return)
			)
		)
	)
	wezel
))

(defun wczytaj (plik)
	(let (
		(str (open plik))
	)

	(wczytaj-wezel str)
))

(defun wypisz (dokument &optional (wciecie 0))
	(dotimes (i wciecie)
		(princ " ")
	)
	(princ "<")
	(princ (get dokument 'nazwa))
	(dolist (i (get dokument 'atrybuty))
		(princ " ")
		(princ (car i))
		(format t "=~S" (cadr i))
	)
	(format t ">~%")
	(dolist (i (get dokument 'wezly))
		(wypisz i (+ wciecie 1))
	)
	(dotimes (i wciecie)
		(princ " ")
	)
	(princ "</")
	(princ (get dokument 'nazwa))
	(princ ">")
	(terpri)
)
